=== modified file 'NEWS'
--- NEWS	2009-12-02 16:21:42 +0000
+++ NEWS	2009-12-04 10:09:11 +0000
@@ -29,7 +29,8 @@
 * The ``BZR_COLUMNS`` envrionment variable can be set to force bzr to
   respect a given terminal width. This can be useful when output is
   redirected or in obscure cases where the default value is not
-  appropriate.
+  appropriate. Pagers can use it to get a better control of the line
+  lengths. 
   (Vincent Ladeuil)
 
 Bug Fixes

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2009-12-02 16:21:42 +0000
+++ bzrlib/osutils.py	2009-12-04 10:09:11 +0000
@@ -1350,12 +1350,6 @@
     except (KeyError, ValueError):
         pass
 
-    # If COLUMNS is set, take it, the terminal knows better
-    try:
-        return int(os.environ['COLUMNS'])
-    except (KeyError, ValueError):
-        pass
-
     isatty = getattr(sys.stdout, 'isatty', None)
     if  isatty is None or not isatty():
         # Don't guess, setting BZR_COLUMNS is the recommended way to override.
@@ -1370,9 +1364,14 @@
         x = fcntl.ioctl(1, termios.TIOCGWINSZ, s)
         width = struct.unpack('HHHH', x)[1]
     except (IOError, AttributeError):
-        return None
+        # If COLUMNS is set, take it
+        try:
+            return int(os.environ['COLUMNS'])
+        except (KeyError, ValueError):
+            return None
 
     if width <= 0:
+        # Consider invalid values as meaning no width
         return None
 
     return width

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2009-12-02 16:21:42 +0000
+++ bzrlib/tests/test_osutils.py	2009-12-04 10:09:11 +0000
@@ -1936,11 +1936,6 @@
         os.environ['BZR_COLUMNS'] = '12'
         self.assertEquals(12, osutils.terminal_width())
 
-    def test_falls_back_to_COLUMNS(self):
-        del os.environ['BZR_COLUMNS']
-        os.environ['COLUMNS'] = '42'
-        self.assertEquals(42, osutils.terminal_width())
-
     def test_tty_default_without_columns(self):
         del os.environ['BZR_COLUMNS']
         del os.environ['COLUMNS']

